import { select } from 'd3';
const svg = select('svg');
const width = document.body.clientWidth;
const height = document.body.clientHeight;

svg.attr('width', width).attr('height', height)

var alphabet = "abcdefghijklmnopqrstuvwxyz".split("");

var g = svg.append("g").attr("transform", "translate(32," + (height / 4) + ")"),
    gGroups = svg.append("g").attr("transform", "translate(32," + (height / 4 * 3) + ")");

function update(data) {
  var t = d3.transition()
      .duration(750);

  // JOIN new data with old elements.
  var text = g.selectAll("text")
    .data(data, function(d) { return d; });

// EXIT old elements not present in new data.
    text.exit()
      .attr("class", "exit")
    .transition(t)
      .attr("y", 60)
      .style("fill-opacity", 1e-6)
      .remove();

  // UPDATE old elements present in new data.
  text.attr("class", "update")
      .attr("y", 0)
      .style("fill-opacity", 1)
    .transition(t)
      .attr("x", function(d, i) { return i * 18; });

  // ENTER new elements present in new data.
  text.enter().append("text")
      .attr("class", "enter")
      .attr("dy", ".35em")
      .attr("y", -60)
      .attr("x", function(d, i) { return i * 18; })
      .style("fill-opacity", 1e-6)
      .text(function(d) { return d; })
    .transition(t)
      .attr("y", 0)
      .style("fill-opacity", 1);
}

d3.select("#btnRandom")
  .on("click", function () {
    update(d3.shuffle(alphabet)
      .slice(0, Math.floor(Math.random() * 26))
      .sort());
  });
